# Use the command-line ldapsearch to do searches rather than Net::LDAP.

package ldap;

my $LDAPHOST = 'cronus.admcs.wwu.edu';
my $LDAPSEARCHPATTERN = qq|/usr/bin/ldapsearch -x -LLL -h ${LDAPHOST} -b '{0}' -s '{1}' '{2}' {3}|;


sub search ($$$$)
{
    my $base   = shift;
    my $scope  = shift;
    my $filter = shift;
    my $attrs  = shift;
    $attrs = join( ' ', @$attrs );

    my %results = ();

    my $llsp = $LDAPSEARCHPATTERN;
    $llsp =~ s/\{0\}/$base/;
    $llsp =~ s/\{1\}/$scope/;
    $llsp =~ s/\{2\}/$filter/;
    $llsp =~ s/\{3\}/$attrs/;

    open( LDS, "$llsp |" ) or die ( "Cannot connect: $!" );
    while ( $line = <LDS> ) {
        $line =~ m/^(.+): (.+)/;
        $results{ $1 } = $2;
    }
    close( LDS );

    return \%results;
}

# MAIN:
# my $results = search( "o=wwu", "sub", "(cn=mclaugtd)", [qw( cn loginTime )] );
# map { print "$_ == " . $results->{$_} . "\n"; } sort( keys( %{$results} ) );

1;